import { Plugin } from 'vite';
import { PageDirOptions } from 'vite-plugin-files';

interface RouteFile {
    path: string;
    file: string;
    exact?: boolean;
    routes?: RouteFile[];
}
interface RouteDirOptions extends PageDirOptions {
    baseRoute: string;
}
/**
 * Plugin options.
 */
interface Options {
    /**
     * Relative path to the directory to search for page components.
     * @default 'src/pages'
     */
    routesDir: RouteDirOptions[];
    /**
     * file extension
     * @default ["tsx"]
     */
    extensions: string[];
    /**
     * List of path globs to exclude when resolving files.
     * @default ["components"]
     */
    exclude?: RegExp[];
    /**
     * import components asynchronously?
     * @default false
     */
    async?: boolean;
}
declare type UserOptions = Partial<Options>;
interface ResolvedOptions extends Options {
}

declare function ViteReactRouter(userOptions: UserOptions): Plugin;

export default ViteReactRouter;
export { ResolvedOptions, RouteDirOptions, RouteFile, UserOptions };
